# -*- coding: utf-8 -*-
"""
Created on Mon Dec 20 14:14:37 2021

@author: msahr
"""

import extractDef as ext
import matplotlib.pyplot as plt
import sys
import re
import math
import DRCdef as drc


    
ListofDRCRules=drc.read_drcrules('drcRules.txt')
print('Done')
ListOfPolyList=ext.read_layout('drc_width_layout.txt')
ListActive=ListOfPolyList
while ListActive is not None:
    Plist=ListActive.PolyList
    while Plist is not None:
        Plist.Polygon.plot('#a0a0a0')
        plt.text(Plist.Polygon.BB.llx,Plist.Polygon.BB.lly,ListActive.Name)
        Plist=Plist.next
    ListActive=ListActive.next


ListOfDRCErrorList=ext.ListOfPolygonList()
DRCRuleActive=ListofDRCRules
while DRCRuleActive is not None:
    Rule=DRCRuleActive
    while Rule is not None:
        RuleActiveName=Rule.Atom.name
        ListOfPolyListActive=ListOfPolyList
        while ListOfPolyListActive is not None:
            if ListOfPolyListActive.Name == Rule.Atom.layer1:
                    polyList=ListOfPolyListActive.PolyList
                    while polyList is not None:
                        ErrorPolygonList=drc.drc_width(polyList.Polygon,ListofDRCRules,ListOfPolyListActive.Name)
                        if ErrorPolygonList is not None:
                            ListOfDRCErrorList.insert(ErrorPolygonList,Rule.Atom.name)
                        polyList=polyList.next
            ListOfPolyListActive=ListOfPolyListActive.next
        while Rule is not None and Rule.Atom.name == RuleActiveName:
            Rule=Rule.next
    DRCRuleActive=DRCRuleActive.next
ErrorsListActive=ListOfDRCErrorList
while ErrorsListActive is not None:
    Error=ErrorsListActive.PolyList
    while Error is not None:
        Error.Polygon.plot('#222222')
        Error=Error.next
    ErrorsListActive=ErrorsListActive.next
plt.axis('on')