# -*- coding: utf-8 -*-
"""
Created on Mon Dec 20 14:14:37 2021

@author: msahr
"""

import extractDef as ext
import matplotlib.pyplot as plt
import sys
import re
import math
import DRCdef as drc
    
ListofDRCRules=drc.read_drcrules('drcRules_antenna.txt')
print('Done')
ListOfPolyList=ext.read_layout('drc_antenna_layout.txt')
ListActive=ListOfPolyList
while ListActive is not None:
    Plist=ListActive.PolyList
    while Plist is not None:
        Plist.Polygon.plot('#a0a0a0')
        if ListActive.Name != 'Poly':
            plt.text(Plist.Polygon.BB.llx,Plist.Polygon.BB.lly,ListActive.Name)
        Plist=Plist.next
    ListActive=ListActive.next

ListOfDRCErrorList=ext.ListOfPolygonList()
DRCRuleActive=ListofDRCRules
while DRCRuleActive is not None:
    Rule=DRCRuleActive
    while Rule is not None:
        if Rule.Atom.Type=='Antenna':
            ErrorPolygonList=drc.drc_antenna(ListOfPolyList,ListofDRCRules)                                
            if ErrorPolygonList is not None:
                ListOfDRCErrorList.insert(ErrorPolygonList,Rule.Atom.name)
        Rule=Rule.next
    DRCRuleActive=DRCRuleActive.next
ErrorsListActive=ListOfDRCErrorList
while ErrorsListActive is not None:
    Error=ErrorsListActive.PolyList
    while Error is not None:
        Error.Polygon.plot('#222222')
        Error=Error.next
    ErrorsListActive=ErrorsListActive.next
plt.axis('on')