# -*- coding: utf-8 -*-
"""
Created on Mon Dec 20 14:14:37 2021

@author: msahr
"""

import extractDef as ext
import matplotlib.pyplot as plt
import sys
import re
import math
import DRCdef as drc
    
ListofDRCRules=drc.read_drcrules('drcRules_density.txt')
print('Done')
ListOfPolyList=ext.read_layout('drc_density_layout_err.txt')
ListActive=ListOfPolyList
while ListActive is not None:
    Plist=ListActive.PolyList
    while Plist is not None:
        Plist.Polygon.plot('#a0a0a0')
#        plt.text(Plist.Polygon.BB.llx,Plist.Polygon.BB.lly,ListActive.Name)
        Plist=Plist.next
    ListActive=ListActive.next

BB=ext.BoundingBox()
BB.llx=BB.lly=ext.MAXV
BB.urx=BB.ury=ext.MINV
ListOfPolyListActive=ListOfPolyList
while ListOfPolyListActive is not None:
    polyListActive=ListOfPolyListActive.PolyList
    while polyListActive is not None:
        BB.llx=ext.MIN(BB.llx,polyListActive.Polygon.BB.llx)
        BB.lly=ext.MIN(BB.lly,polyListActive.Polygon.BB.lly)
        BB.urx=ext.MAX(BB.urx,polyListActive.Polygon.BB.urx)
        BB.ury=ext.MAX(BB.ury,polyListActive.Polygon.BB.ury)
        polyListActive=polyListActive.next
    ListOfPolyListActive=ListOfPolyListActive.next

ListOfDRCErrorList=ext.ListOfPolygonList()
DRCRuleActive=ListofDRCRules
while DRCRuleActive is not None:
    Rule=DRCRuleActive
    while Rule is not None:
        ListOfPolyListActive=ListOfPolyList
        while ListOfPolyListActive is not None:
            if ListOfPolyListActive.Name == Rule.Atom.layer1 and Rule.Atom.Type=='Density':
                        ErrorPolygonList=drc.drc_density(ListOfPolyListActive.PolyList,ListofDRCRules,ListOfPolyListActive.Name, BB)
                        if ErrorPolygonList is not None:
                            ListOfDRCErrorList.insert(ErrorPolygonList,Rule.Atom.name)
            ListOfPolyListActive=ListOfPolyListActive.next
        Rule=Rule.next
    DRCRuleActive=DRCRuleActive.next
ErrorsListActive=ListOfDRCErrorList
while ErrorsListActive is not None:
    Error=ErrorsListActive.PolyList
    while Error is not None:
        Error.Polygon.plot('#222222')
        # Error.Polygon.print()
        Error=Error.next
    ErrorsListActive=ErrorsListActive.next
#plt.axis('on')